#!/usr/bin/python3

# Author: - Redacted for GDPR Reasons
# Date: 07.06.22
# Version 2.0
# Description: Reads files with PON (Python Object Notation) and outputs files with JSON

# Please modify the two following variables according to your needs:
path_original = "/put/your/path/to/your/checkmk-file/here/"
path_output = "/put/your/path/to/your/converted/json-files/here/"

import json, glob, ast, os

# All files with a fileending of .* (dot in the name) will be ignored,
# since CheckMK-Files don't have a fileextension.
list_files_all = []
list_files_to_ignore = []
list_files_to_convert = []

def collect_files(path):
    print("Inputfolder: " + path_original)
    for fname in glob.glob(path + "*"):
        if os.path.isfile(fname):
            short_fname = fname.replace(path, "")
            list_files_all.append(short_fname)
    for fname in glob.glob(path + "*.*"):
        if os.path.isfile(fname):
            short_fname = fname.replace(path, "")
            list_files_to_ignore.append(short_fname)
    print("Files found:")
    print(list_files_all)
    print("Files to ignore:")
    print(list_files_to_ignore)
    list_files_to_convert = set(list_files_all) - set(list_files_to_ignore)
    print("Files to convert:")
    print(list_files_to_convert)
    return list_files_to_convert

def json_write(list_files_to_convert):
    for elem in list_files_to_convert:
        json_file = open(path_output+elem, "w")
        orig_file = open(path_original+elem, "r")
        json.dump(ast.literal_eval(orig_file.read()), json_file)
        json_file.close()
        orig_file.close()
        print(elem + " converted...")

if __name__ == "__main__":
    json_write(collect_files(path_original))
    print("Outputfolder: " + path_output)
    print("Done")
